//
// auto-generated by ops.py
//

#ifdef OCL_FMA
#pragma OPENCL FP_CONTRACT ON
#else
#pragma OPENCL FP_CONTRACT OFF
#endif
#pragma OPENCL EXTENSION cl_khr_fp64:enable

#include "ops_opencl_reduction.h"

#ifndef MIN
#define MIN(a,b) ((a<b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a,b) ((a>b) ? (a) : (b))
#endif
#ifndef SIGN
#define SIGN(a,b) ((b<0.0) ? (a*(-1)) : (a))
#endif
#define OPS_READ 0
#define OPS_WRITE 1
#define OPS_RW 2
#define OPS_INC 3
#define OPS_MIN 4
#define OPS_MAX 5
#define ZERO_double 0.0;
#define INFINITY_double INFINITY;
#define ZERO_float 0.0f;
#define INFINITY_float INFINITY;
#define ZERO_int 0;
#define INFINITY_int INFINITY;
#define ZERO_uint 0;
#define INFINITY_uint INFINITY;
#define ZERO_ll 0;
#define INFINITY_ll INFINITY;
#define ZERO_ull 0;
#define INFINITY_ull INFINITY;
#define ZERO_bool 0;

#undef OPS_ACC0
#undef OPS_ACC1
#undef OPS_ACC2
#undef OPS_ACC3
#undef OPS_ACC4
#undef OPS_ACC5
#undef OPS_ACC6


#define OPS_ACC0(x,y,z) (x+xdim0_taylor_green_vortex_block0_17_kernel*(y)+xdim0_taylor_green_vortex_block0_17_kernel*ydim0_taylor_green_vortex_block0_17_kernel*(z))
#define OPS_ACC1(x,y,z) (x+xdim1_taylor_green_vortex_block0_17_kernel*(y)+xdim1_taylor_green_vortex_block0_17_kernel*ydim1_taylor_green_vortex_block0_17_kernel*(z))
#define OPS_ACC2(x,y,z) (x+xdim2_taylor_green_vortex_block0_17_kernel*(y)+xdim2_taylor_green_vortex_block0_17_kernel*ydim2_taylor_green_vortex_block0_17_kernel*(z))
#define OPS_ACC3(x,y,z) (x+xdim3_taylor_green_vortex_block0_17_kernel*(y)+xdim3_taylor_green_vortex_block0_17_kernel*ydim3_taylor_green_vortex_block0_17_kernel*(z))
#define OPS_ACC4(x,y,z) (x+xdim4_taylor_green_vortex_block0_17_kernel*(y)+xdim4_taylor_green_vortex_block0_17_kernel*ydim4_taylor_green_vortex_block0_17_kernel*(z))
#define OPS_ACC5(x,y,z) (x+xdim5_taylor_green_vortex_block0_17_kernel*(y)+xdim5_taylor_green_vortex_block0_17_kernel*ydim5_taylor_green_vortex_block0_17_kernel*(z))
#define OPS_ACC6(x,y,z) (x+xdim6_taylor_green_vortex_block0_17_kernel*(y)+xdim6_taylor_green_vortex_block0_17_kernel*ydim6_taylor_green_vortex_block0_17_kernel*(z))


//user function
void taylor_green_vortex_block0_17_kernel(const __global double * restrict rho,const __global double * restrict rhou0,const __global double * restrict rhou1,
const __global double * restrict rhou2,__global double * restrict u0,__global double * restrict u1,__global double * restrict u2)


{
    u0[OPS_ACC4(0,0,0)] = rhou0[OPS_ACC1(0,0,0)]/rho[OPS_ACC0(0,0,0)];
    u1[OPS_ACC5(0,0,0)] = rhou1[OPS_ACC2(0,0,0)]/rho[OPS_ACC0(0,0,0)];
    u2[OPS_ACC6(0,0,0)] = rhou2[OPS_ACC3(0,0,0)]/rho[OPS_ACC0(0,0,0)];
}



__kernel void ops_taylor_green_vortex_block0_17_kernel(
__global const double* restrict arg0,
__global const double* restrict arg1,
__global const double* restrict arg2,
__global const double* restrict arg3,
__global double* restrict arg4,
__global double* restrict arg5,
__global double* restrict arg6,
const int base0,
const int base1,
const int base2,
const int base3,
const int base4,
const int base5,
const int base6,
const int size0,
const int size1,
const int size2 ){


  int idx_y = get_global_id(1);
  int idx_z = get_global_id(2);
  int idx_x = get_global_id(0);

  if (idx_x < size0 && idx_y < size1 && idx_z < size2) {
    taylor_green_vortex_block0_17_kernel(&arg0[base0 + idx_x * 1*1 + idx_y * 1*1 * xdim0_taylor_green_vortex_block0_17_kernel + idx_z * 1*1 * xdim0_taylor_green_vortex_block0_17_kernel * ydim0_taylor_green_vortex_block0_17_kernel],
                                         &arg1[base1 + idx_x * 1*1 + idx_y * 1*1 * xdim1_taylor_green_vortex_block0_17_kernel + idx_z * 1*1 * xdim1_taylor_green_vortex_block0_17_kernel * ydim1_taylor_green_vortex_block0_17_kernel],
                                         &arg2[base2 + idx_x * 1*1 + idx_y * 1*1 * xdim2_taylor_green_vortex_block0_17_kernel + idx_z * 1*1 * xdim2_taylor_green_vortex_block0_17_kernel * ydim2_taylor_green_vortex_block0_17_kernel],
                                         &arg3[base3 + idx_x * 1*1 + idx_y * 1*1 * xdim3_taylor_green_vortex_block0_17_kernel + idx_z * 1*1 * xdim3_taylor_green_vortex_block0_17_kernel * ydim3_taylor_green_vortex_block0_17_kernel],
                                         &arg4[base4 + idx_x * 1*1 + idx_y * 1*1 * xdim4_taylor_green_vortex_block0_17_kernel + idx_z * 1*1 * xdim4_taylor_green_vortex_block0_17_kernel * ydim4_taylor_green_vortex_block0_17_kernel],
                                         &arg5[base5 + idx_x * 1*1 + idx_y * 1*1 * xdim5_taylor_green_vortex_block0_17_kernel + idx_z * 1*1 * xdim5_taylor_green_vortex_block0_17_kernel * ydim5_taylor_green_vortex_block0_17_kernel],
                                         &arg6[base6 + idx_x * 1*1 + idx_y * 1*1 * xdim6_taylor_green_vortex_block0_17_kernel + idx_z * 1*1 * xdim6_taylor_green_vortex_block0_17_kernel * ydim6_taylor_green_vortex_block0_17_kernel]);
  }

}
