//
// auto-generated by ops.py
//

#ifdef OCL_FMA
#pragma OPENCL FP_CONTRACT ON
#else
#pragma OPENCL FP_CONTRACT OFF
#endif
#pragma OPENCL EXTENSION cl_khr_fp64:enable

#include "ops_opencl_reduction.h"

#ifndef MIN
#define MIN(a,b) ((a<b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a,b) ((a>b) ? (a) : (b))
#endif
#ifndef SIGN
#define SIGN(a,b) ((b<0.0) ? (a*(-1)) : (a))
#endif
#define OPS_READ 0
#define OPS_WRITE 1
#define OPS_RW 2
#define OPS_INC 3
#define OPS_MIN 4
#define OPS_MAX 5
#define ZERO_double 0.0;
#define INFINITY_double INFINITY;
#define ZERO_float 0.0f;
#define INFINITY_float INFINITY;
#define ZERO_int 0;
#define INFINITY_int INFINITY;
#define ZERO_uint 0;
#define INFINITY_uint INFINITY;
#define ZERO_ll 0;
#define INFINITY_ll INFINITY;
#define ZERO_ull 0;
#define INFINITY_ull INFINITY;
#define ZERO_bool 0;

#undef OPS_ACC0
#undef OPS_ACC1
#undef OPS_ACC2
#undef OPS_ACC3


#define OPS_ACC0(x,y,z) (x+xdim0_taylor_green_vortex_block0_18_kernel*(y)+xdim0_taylor_green_vortex_block0_18_kernel*ydim0_taylor_green_vortex_block0_18_kernel*(z))
#define OPS_ACC1(x,y,z) (x+xdim1_taylor_green_vortex_block0_18_kernel*(y)+xdim1_taylor_green_vortex_block0_18_kernel*ydim1_taylor_green_vortex_block0_18_kernel*(z))
#define OPS_ACC2(x,y,z) (x+xdim2_taylor_green_vortex_block0_18_kernel*(y)+xdim2_taylor_green_vortex_block0_18_kernel*ydim2_taylor_green_vortex_block0_18_kernel*(z))
#define OPS_ACC3(x,y,z) (x+xdim3_taylor_green_vortex_block0_18_kernel*(y)+xdim3_taylor_green_vortex_block0_18_kernel*ydim3_taylor_green_vortex_block0_18_kernel*(z))


//user function
void taylor_green_vortex_block0_18_kernel(const __global double * restrict u0,const __global double * restrict u1,const __global double * restrict u2,
const __global double * restrict rho, double * restrict ke, double * restrict enstrophy, double * restrict rhomean,

  const double rinv1,
const double rinv4,
const double rinv5,
const double rc0,
const double rc2,
const double rc3)


{
    double temp_eval0 = rinv5*((rc2)*u1[OPS_ACC1(-2,0,0)] - rc3*u1[OPS_ACC1(-1,0,0)] + (rc3)*u1[OPS_ACC1(1,0,0)] -
      rc2*u1[OPS_ACC1(2,0,0)]);
    double temp_eval1 = rinv4*((rc2)*u0[OPS_ACC0(0,-2,0)] - rc3*u0[OPS_ACC0(0,-1,0)] + (rc3)*u0[OPS_ACC0(0,1,0)] -
      rc2*u0[OPS_ACC0(0,2,0)]);
    double temp_eval2 = rinv4*((rc2)*u2[OPS_ACC2(0,-2,0)] - rc3*u2[OPS_ACC2(0,-1,0)] + (rc3)*u2[OPS_ACC2(0,1,0)] -
      rc2*u2[OPS_ACC2(0,2,0)]);
    double temp_eval3 = rinv1*((rc2)*u0[OPS_ACC0(0,0,-2)] - rc3*u0[OPS_ACC0(0,0,-1)] + (rc3)*u0[OPS_ACC0(0,0,1)] -
      rc2*u0[OPS_ACC0(0,0,2)]);
    double temp_eval4 = rinv5*((rc2)*u2[OPS_ACC2(-2,0,0)] - rc3*u2[OPS_ACC2(-1,0,0)] + (rc3)*u2[OPS_ACC2(1,0,0)] -
      rc2*u2[OPS_ACC2(2,0,0)]);
    double temp_eval5 = rinv1*((rc2)*u1[OPS_ACC1(0,0,-2)] - rc3*u1[OPS_ACC1(0,0,-1)] + (rc3)*u1[OPS_ACC1(0,0,1)] -
      rc2*u1[OPS_ACC1(0,0,2)]);
    *ke = *ke + (rc0)*(pow(u0[OPS_ACC0(0,0,0)], 2) + pow(u1[OPS_ACC1(0,0,0)], 2) + pow(u2[OPS_ACC2(0,0,0)],
      2))*rho[OPS_ACC3(0,0,0)];
    *enstrophy = *enstrophy + (rc0)*(pow(temp_eval0 - temp_eval1, 2) + pow(temp_eval2 - temp_eval5, 2) + pow(temp_eval3
      - temp_eval4, 2))*rho[OPS_ACC3(0,0,0)];
   *rhomean = *rhomean + rho[OPS_ACC3(0,0,0)];
}



__kernel void ops_taylor_green_vortex_block0_18_kernel(
__global const double* restrict arg0,
__global const double* restrict arg1,
__global const double* restrict arg2,
__global const double* restrict arg3,
__global double* restrict arg4,
__local double* scratch4,
int r_bytes4,
__global double* restrict arg5,
__local double* scratch5,
int r_bytes5,
__global double* restrict arg6,
__local double* scratch6,
int r_bytes6,
const double rinv1,
const double rinv4,
const double rinv5,
const double rc0,
const double rc2,
const double rc3,
const int base0,
const int base1,
const int base2,
const int base3,
const int size0,
const int size1,
const int size2 ){

  arg4 += r_bytes4;
  double arg4_l[1];
  arg5 += r_bytes5;
  double arg5_l[1];
  arg6 += r_bytes6;
  double arg6_l[1];
  for (int d=0; d<1; d++) arg4_l[d] = ZERO_double;
  for (int d=0; d<1; d++) arg5_l[d] = ZERO_double;
  for (int d=0; d<1; d++) arg6_l[d] = ZERO_double;

  int idx_y = get_global_id(1);
  int idx_z = get_global_id(2);
  int idx_x = get_global_id(0);

  if (idx_x < size0 && idx_y < size1 && idx_z < size2) {
    taylor_green_vortex_block0_18_kernel(&arg0[base0 + idx_x * 1*1 + idx_y * 1*1 * xdim0_taylor_green_vortex_block0_18_kernel + idx_z * 1*1 * xdim0_taylor_green_vortex_block0_18_kernel * ydim0_taylor_green_vortex_block0_18_kernel],
                                         &arg1[base1 + idx_x * 1*1 + idx_y * 1*1 * xdim1_taylor_green_vortex_block0_18_kernel + idx_z * 1*1 * xdim1_taylor_green_vortex_block0_18_kernel * ydim1_taylor_green_vortex_block0_18_kernel],
                                         &arg2[base2 + idx_x * 1*1 + idx_y * 1*1 * xdim2_taylor_green_vortex_block0_18_kernel + idx_z * 1*1 * xdim2_taylor_green_vortex_block0_18_kernel * ydim2_taylor_green_vortex_block0_18_kernel],
                                         &arg3[base3 + idx_x * 1*1 + idx_y * 1*1 * xdim3_taylor_green_vortex_block0_18_kernel + idx_z * 1*1 * xdim3_taylor_green_vortex_block0_18_kernel * ydim3_taylor_green_vortex_block0_18_kernel],
                                         arg4_l,
                                         arg5_l,
                                         arg6_l,
                                         rinv1,
                                         rinv4,
                                         rinv5,
                                         rc0,
                                         rc2,
                                         rc3);
  }
  int group_index = get_group_id(0) + get_group_id(1)*get_num_groups(0)+ get_group_id(2)*get_num_groups(0)*get_num_groups(1);
  for (int d=0; d<1; d++)
    reduce_double(arg4_l[d], scratch4, &arg4[group_index*1+d], OPS_INC);
  for (int d=0; d<1; d++)
    reduce_double(arg5_l[d], scratch5, &arg5[group_index*1+d], OPS_INC);
  for (int d=0; d<1; d++)
    reduce_double(arg6_l[d], scratch6, &arg6[group_index*1+d], OPS_INC);

}
